(module index mzscheme

 (require
  (file "../missing.scm")
  (file "../teaching.ss")
  (file "../web-page.ss")  
  (lib "xml.ss" "xml"))
 
 (define WEEKS '(1 2 3 4 5 6 7 8 9 10 11 12 13 14))

  ;; (listof (list String[title] String[link]))
  (define LINKS-211
    (checked-links
     `(;("Teaching"    "../../index.html")
       (,THIS-COURSE  "../index.html")
       (nbsp #f)
       ("Assignments" "index.html")
       ,@(map (lambda (x) `(,(format "Set ~a" x) ,(format "~a.html" x))) WEEKS))))
  
  ; String[out file] String[page title] (union String false) Xexpr -> Void
  ;; produce and write out a page
  (define (write-normal-page file title xml)
    (produce-page 
     file
     (html title #f
           (reverse (remove-link title (reverse LINKS-211)))
           xml)))
  
  ; String[page title] (union String false) Xexpr -> Void
  ;; produce an index page
  (define (write-index-page title icon xml)
    (produce-page 
     "index.html" 
     (html title icon (remove-link "Assignments" LINKS-211) xml)))
 
  (define (read-assignment no)
    (read-assignment-from-file (format "~a.xml" no)))

  (define (read-assignment-from-file file)
    (let* ([x (read-xml/element (open-input-file file))]
           [y (xml->xexpr x)]
	   ;; assert: (assignment ...) must occur in (cdr y)
           [z (let loop ([y (cdr y)])
                (if (and (pair? (car y)) (eq? (caar y) 'assignment))
		    (let ((body (cdr (car y))))
		      (if (and (pair? (car body))
			       (pair? (caar body))
			       (eq? (caaar body) 'due))
			  `(div
			    (p (font ([color "red"]) "Due date: ")
			       ,(cadaar body)
			       (font ([color "red"]) " @ 4:30 pm"))
			    ,@(cdr body)
			    (p
			     (b "Optional:")
			     (blockquote
			      "Please explain any problems you had "
			      "completing this assignment in no more than 30 words.")))
			  `(div ,@body)))
                    (loop (cdr y))))])
      (xexpr->xml z)))

  (write-index-page 
   "Assignments" #f 
   `(div
     (blockquote
      (p "Submit homework set 1 in printed form at the beginning of "
         "class on Monday, 1/10, to your instructor.")
;      (p "All assignments must contain a 30-word description of any "
;	 "problem you encountered in completing the assignment.  This must "
;	 "be exactly 30 words -- no more, no less.")
      (p "Instructions for assignments 2-10 will follow."))))

  '(center
     (a ([href "http://subra.ccs.neu.edu:8124/servlets/hw.ss"])
	"The Electronic Submission Form"))

  ;; assignments
 (map (lambda (x)
	(let ([a (read-assignment x)])
	  (write-normal-page
	    (format "~a.html" x)
	    (format "Problem Set ~a" x)
	    a)))
       WEEKS)
  
  )
