(module index mzscheme
  
  ;; README
  ;; This will generate a gallery from the images and xml files
  ;; in this directory.  Use by the following:
  ;;
  ;;  1. Add a String <name> to (names)
  ;;  2. Add an image <name>.jpg and entry <name>.xml.
  ;;     Entry has the structure:
  ;;       Entry ::= (entry (name String) (description String))

  (require 
   (file "gallery.ss")
   (file "../basics.scm"))

  ;; main
  (write-normal-page "../gallery.html" "Gallery" #f 
		     `(div
		       (p (a ([href "Gallery/instructions.html"]) "Instructions") " for this project.")
		       ,(create-entries)))
  (write-normal-page 
   "instructions.html" "Gallery instructions" #f
   `(div
     (p "I'd like to create a photo gallery for the class."
	"  Here's what I'd like you to do:")
     (ol
      (li "Get a digital photo of yourself that will look decent at around 100x100 pixels."
	  "It should probably be just head-and-shoulders, but the goal is to make you recognizable."
	  "I would prefer you do this in groups. Go out and take each other's pictures.")
      (li "Store it as a jpg, and crop and resize it so the resulting image is about 100 pixels wide.")
      (li "Mail this picture to me (jpalm @ ccs) with the subject "
	  (code "211 gallery")
	  " and include the following:"
	  (ol
	   (li "Your name")
	   (li "A brief description of yourself"))))
     "Back to the " (a ([href "../gallery.html"]) "gallery") "."
     ))
  )
