(module basics mzscheme 
  
  (require 
   (file "missing.scm")
   (file "teaching.ss")
   (file "web-page.ss")  
   (lib "xml.ss" "xml")
   (file "blog-aux.scm")
   (file "rdf.ss")
   )
  
  (provide 
   red-title-word 
   write-normal-page
   write-index-page
   create-normal-page
   write-blog
   )
  
  ;; (listof (list String[title] String[link]))
  (define LINKS-211
    (checked-links
     (append
      (remove-links (course-links THIS-COURSE HOME-DIR) "Assignments")
      '(("Assignments"   "Assignments/index.html")
        ("Communication" "communication.html")
        ("Blog"          "blog.html")
        ("Labs"          "labs.html")
        ("Ofc Hrs"       "officehours.html")
        ("Advice"        "advice.html")
        ("Stories"       "story.html")
        ("Gallery"       "gallery.html")
        ("DrScheme"      "http://www.drscheme.org/")
        ))))
  
  ; String -> Xexpr[p]
  ;; a red-colored italics word 
  (define (red-title-word title) `(font ([color "red"][style "italic"]) ,title ": "))
  
  ; --> this was an attempt to turn this whole thing into a class hierarchy
  ; --> another time 
  
  ; String[page title] (union String false) Xexpr -> Xexpr[html]
  ;; produce a page
  (define (create-normal-page title icon xml)
    (html title icon (remove-link title LINKS-211) xml))
  
  ; String[out file] String[page title] (union String false) Xexpr -> Void
  ;; produce and write out a page
  (define (write-normal-page file title icon xml)
    (produce-page file (create-normal-page title icon xml)))
  
  ; String[page title] (union String false) Xexpr -> Void
  ;; produce an index page
  (define (write-index-page title icon xml)
    (produce-page "index.html" (html title icon (remove-link THIS-COURSE LINKS-211) xml)))
  
  ;; -> Void
  (define (write-blog)
    (let* ([link  (format "~a/blog.html" FULL-URL)]
           [title (format "Blog for ~a" THIS-COURSE)]
           [descr (format "~a Blog" THIS-COURSE)]
           [files (blog write-normal-page link title descr)]
           [xml (car files)]
           [rdf (cadr files)])
      (produce-page "blog.html" 
		    (add-rdf-info (create-normal-page 
				   (format "~a Blog" THIS-COURSE) #f xml) FULL-URL))
      (produce-page "index.xml" rdf)))

  )
