(module teaching mzscheme
  (require (file "missing.scm")
           (file "web-page.ss")
           (lib "list.ss"))
  
  (provide 
   course-links  ; String -> (Listof Nav-Links)
   remove-links  ; (Listof Nav-Links) String *-> (Listof Nav-Links)
   )
  
  ;; using HOME-DIR(define HOME "/home/matthias/")
  
  ; String -> (listof Nav-Link)
  ; produce a standard list of links from course Title 
  (define (course-links course . alt-home)
    (let ([HOME (if (null? alt-home) HOME-DIR (car alt-home))])
      `(("Home"          ,HOME)
        ;;nope ("Teaching"      ,(string-append HOME "teaching.html"))
        ,LINE
        (,course         "index.html")
        ("General"       "general.html")
        ("Texts"         "readings.html")
        ("Syllabus"      "syllabus.html")
        ("Assignments"   "assignments.html"))))
  
  ; (listof Nav-Link) String *-> (listof Nav-Link)
  ; remove the links in the optional argument (based on same "title")
  (define (remove-links links . to-be-removed)
    (foldr (lambda (f r)
             (let remove-links ([links r])
               (cond
                 [(pair? links) 
                  (if (and (string? (caar links)) (regexp-match (caar links) f))
                      (remove-links (cdr links))
                      (cons (car links) (remove-links (cdr links))))]
                 [else '()])))
           links
           to-be-removed))
  
  
  
)
